package SomLib;

import main.ACLibrary;
import main.ACMeta;

import java.io.BufferedWriter;
import java.io.FileWriter;

import features.ACFStatistics;

/**
 * Created by IntelliJ IDEA.
 * User: mac
 * Date: 15.10.2009
 * Time: 17:04:38
 * To change this template use File | Settings | File Templates.
 */
public class SomLibWriter
{
    public static void writeTemplateVectorFile(String path, ACLibrary lib)
    {
        try
        {
            BufferedWriter out = new BufferedWriter(new FileWriter(path + ".tv"));

            //header

            //out.write("#SomLib template vector file, generated by audiocompare (maczejka,seidl)\n");
            out.write("$TYPE template\n");
            out.write("$XDIM 2\n");
            out.write("$YDIM "+xdim(lib)+"\n");
            out.write("$VEC_DIM " + (ACFStatistics.VEC_SIZE) + "\n");

            int i = 0;
            for (String s : ACFStatistics.getDescriptions())
            {
                out.write(i + " " + s + "\n");
                i++;
            }

            out.close();
        }
        catch  (Exception ex)
        {

        }
    }

    public static void writeInputVectorFile(String path, ACLibrary lib)
    {
        try
        {
            BufferedWriter out = new BufferedWriter(new FileWriter(path + ".vec"));

            //header

            //out.write("#SomLib input vector file, generated by audiocompare (maczejka,seidl)\n");
            out.write("$EXTRACTOR audiocompare(maczejka,seidl)\n");
            out.write("$TYPE vec\n");
            out.write("$XDIM " + xdim(lib) + "\n");
            out.write("$YDIM 1\n");

            out.write("$ATTR ");

            int i = 0;
            for (String s : ACFStatistics.getDescriptions())
            {
                out.write(s + " ");
                i++;
            }
            out.write("\n");

            out.write("$VEC_DIM " + (ACFStatistics.VEC_SIZE) + "\n");

            for (ACMeta m : lib.mfiles)
            {
                writeSomVec(out, m);
            }

            out.close();
        }
        catch  (Exception ex)
        {

        }
    }

    public static void writeSomVec(BufferedWriter out, ACMeta m)
    {
        try
        {
            ACFStatistics s = (ACFStatistics)m.getFeatureByID("Statistics");

            for  (double d : s.stats)
            {
                out.write(d + " ");
            }

            out.write(m.relPath + "\n");
        }
        catch  (Exception ex)
        {
        }
    }

    public static int xdim(ACLibrary lib)
    {
        return lib.mfiles.size();        
    }
}
