package comparison;

/**
 * created by as part of comparison
 * User: mac
 * Date: 03.08.2009
 * Time: 22:34:50
 */
public class ACCHamming extends ACComparison
{
    public ACCHamming()
    {
        CName = "Hamming Distance";
        CType = TYPE_STRING;
    }

    public double compareDoublevect (double[] x, double[] y)
    {
        return 0;
    }
    
    public double compareString(String x, String y)
    {
        String large, small;

        //find longer string
        large = x;
        small = y;

        if (x.length() < y.length())
        {
            large = y;
            small = x;
        }

        int lendiff = large.length() - small.length();
        double dist = small.length();  //hamming distance decided on on this string tuple

        //move small string over large sting in same size window, compute hamming distance
        for (int i = 0; i < lendiff-1; i++)
        {
            double hd = 0; //hamming distance of this window

            for (int j = 0; j < small.length()-1; j++)
            {
                if (!small.substring(j,j+1).equals(large.substring(i+j,i+j+1))) hd++;
            }

            //this version: minimum window distance
            if (hd < dist) dist = hd;
        }


        return dist / (double)small.length(); //percentage of distance
    }

}
