package comparison;

/**
 * Created by IntelliJ IDEA.
 * User: mac
 * Date: 25.06.2009
 * Time: 17:17:01
 * To change this template use File | Settings | File Templates.
 */
public class ACCLevenshtein extends ACComparison
{
    public ACCLevenshtein()
    {
        CName = "Levenshtein Distance";
        CType = TYPE_STRING;
    }

    public double compareDoublevect(double[] x, double[] y)
    {
        return 0;
    }

    public double compareString(String x, String y)
    {
        int n = x.length();
        int m = y.length();

        //max distance is length of longest string

        double max = Math.max(n, m);

        if (n == 0 || m == 0) return 0;

        int[][] matrix = new int[n+1][m+1];


        for (int i = 0; i < n; i++) matrix[i][0] = i;
        for (int j = 1; j < m; j++) matrix[0][j] = j;

        // s = x
        // t = y

        for (int i = 1; i <= n; i++)
        {
            for (int j = 1; j <= m; j++)
            {
                int cost = 1;
                if (x.charAt(i-1) == y.charAt(j-1)) cost = 0;

                matrix[i][j] = Math.min(Math.min(matrix[i-1][j]+1 , matrix[i][j-1]+1), matrix[i-1][j-1] + cost);

            }
        }

        double dist = matrix[n][m];


        //print matrix
        /*
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
                System.out.print(matrix[i][j] + " ");
            System.out.println("");
        }
        */


        //System.out.println("dist=" + dist + "\t max=" + max);
        return 1-(dist/max);
    }
}
