package comparison;

/**
 * Created by IntelliJ IDEA.
 * User: mac
 * Date: 25.06.2009
 * Time: 15:44:42
 * To change this template use File | Settings | File Templates.
 */
public abstract class ACComparison implements java.io.Serializable
{
    public String CName = "Unknown Comparison";
    public int CType = TYPE_UNKNOWN;

    public static final int TYPE_UNKNOWN = 0;
    public static final int TYPE_STRING = 1;
    public static final int TYPE_DOUBLEVECT = 2;
    public static final int TYPE_STRINGVECT = 3;

    public abstract double compareString(String x, String y);
    public abstract double compareDoublevect (double[] x, double[] y);

    public static String[] getAllowedAlgorihtms(int type)
    {
        String[] res;
        switch (type)
        {
            case TYPE_STRING:
                res = new String[3];
                res[0] = "Dice's Coefficient";
                res[1] = "Hamming Distance";
                res[2] = "Levenshtein Distance";

                return res;

            case TYPE_DOUBLEVECT:
                res = new String[1];
                res[0] = "Euclidean Distance";               
                return res;

            case TYPE_STRINGVECT:
                return ACComparison.getAllowedAlgorihtms(TYPE_STRING);
        }

        return null;
    }

    public static ACComparison comparisonFactory(String id)
    {
       if (id.equals("Dice's Coefficient")) return new ACCDice();
       else if (id.equals("Hamming Distance")) return new ACCHamming();
       else if (id.equals("Levenshtein Distance")) return new ACCLevenshtein();
       else if (id.equals("Euclidean Distance")) return new ACCEuclidean();

       return null;
    }

    public double compareStringvect(String[] x, String[] y)
    {
       //get longest entry
        int max = 0;

        String maxs = "";
       for (String s : x)
       {
         if (s.length() > max) {max = s.length();}
       }

        for (String s : y)
       {
         if (s.length() > max) max = s.length();
       }

        System.out.println("longest entry=" + max);
        //normalize length

       for (int i = 0; i < x.length; i++)
       {
           while (x[i].length() < max) x[i] += " ";
       }

        for (int i = 0; i < y.length; i++)
       {
           while (y[i].length() < max) y[i] += " ";
       }

        return compareString(implode(x,""), implode(y,""));
    }


    public static String implode(String[] ary, String delim)
    {
    String out = "";
    for(int i=0; i<ary.length; i++) {
        if(i!=0) { out += delim; }
        out += ary[i];
    }
    return out;
}
}
