package features;

/**
 * Created by IntelliJ IDEA.
 * User: mac
 * Date: 25.06.2009
 * Time: 11:24:28
 * To change this template use File | Settings | File Templates.
 */

import java.util.*;
import java.io.BufferedReader;
import java.io.IOException;

import jm.music.data.Score;
import jm.music.data.Part;
import jm.music.data.Phrase;
import jm.music.data.Note;
import comparison.ACCDice;
import comparison.ACCLevenshtein;
import comparison.ACCHamming;
import comparison.ACComparison;

public class ACFParson extends ACFeature
{
    public String[] pcodes;
    
    public ACFParson()
    {
        this.featureID = "Parsons Code";
    }

    public String[] allowedCompareAlgorithms()
    {
        return ACComparison.getAllowedAlgorihtms(ACComparison.TYPE_STRING);
    }

    public String serialise()
    {
        String ser = featureID + "\nLines:" + pcodes.length + "\n";
        for (String pcode : pcodes)
        {
            ser += pcode + "\n";
        }
        return ser;
    }

    public void deserialise(BufferedReader in)
    {
        try
        {
            //line 1: <name/debug>:<numlines>

            String lone = in.readLine();

            lone = lone.substring(lone.indexOf(':')+1);

            int nlines = Integer.parseInt(lone);

            pcodes = new String[nlines];

            for (int i = 0; i < nlines; i++)
            {
              pcodes[i] = in.readLine();  
            }

        }
        catch (IOException ex)
        {
            //fail!
        }
    }

    public void print()
    {
        for (int i=0; i < pcodes.length; i++)
        {
            System.out.println("[parsons]\t" + i + "(" + pcodes[i].length() + "):  " + pcodes[i]);
        }
    }

    public void extract (Score s)
    {

        ArrayList<String> PCode = new ArrayList<String>();

	    Enumeration e = s.getPartList().elements();

        while (e.hasMoreElements())
        {                                                                          
            Part nextPt = (Part) e.nextElement();


            //filter out percussion track
            if (nextPt.getChannel() == 10) continue;

            String b = "";

            Vector<Note> notes = mergePhrases(nextPt);

            for (Note note : notes)
            {
               if (!note.isRest())  b += upOrDown(note.getPitch());
            }
            /*
            Enumeration e2 = nextPt.getPhraseList().elements();

            while (e2.hasMoreElements())
            {

                Phrase nextPhr = (Phrase) e2.nextElement();
                Enumeration e3 = nextPhr.getNoteList().elements();

                while (e3.hasMoreElements())
                {
                    Note nextNote = (Note) e3.nextElement();

                    if (!nextNote.isRest())  b += upOrDown(nextNote.getPitch());

                }
            }
            */

            if (!isBeat(b)) PCode.add(b);
        }

        pcodes = new String[PCode.size()];

        for (int i = 0; i < PCode.size(); i++)
            pcodes[i] = PCode.get(i);
    }

    public double compare(ACFeature p)
    {
        //not a valid comparison
        if (ACFParson.class != p.getClass()) return 0;


        ACFParson cp = (ACFParson)p;

        //compare each string to each string, return best match

        double top = 0;

        for (int i = 0; i < pcodes.length; i++)
        {
            for   (int j = 0; j < cp.pcodes.length; j++)
            {
                //ACCDice dc = new ACCDice(pcodes[i], cp.pcodes[j]);
                //ACCLevenshtein dc = new ACCLevenshtein(pcodes[i], cp.pcodes[j]);
                //ACCHamming dc = new ACCHamming(pcodes[i], cp.pcodes[j]);
                //double val = dc.compare();

                ACComparison cc = ACComparison.comparisonFactory(compareAlgorithm);
                double val = cc.compareString(pcodes[i], cp.pcodes[j]);

                if (val > top) top = val;
            }
        }

        return top;
    }



   
}
