package gui;

import features.ACFeature;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.*;

import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.CellConstraints;

/**
 * Created by IntelliJ IDEA.
 * User: Christian Seidl
 * Date: 08.10.2009
 * Time: 17:00:32
 * To change this template use File | Settings | File Templates.
 */
public class ACFeatureSelect {
    public String getFeature() {
        return (String) cbFeature.getSelectedItem();
    }

    public void setFeatures(String[] features) {
        for (String f : features) {
            cbFeature.addItem(f);
        }
    }

    public String getComparison() {
        return (String) cbComparison.getSelectedItem();
    }

    private void setComparisons(String[] comparison) {
        cbComparison.removeAllItems();
        for (String c : comparison) {
            cbComparison.addItem(c);
        }
    }

    private JComboBox cbFeature;
    public JPanel panelFeatureSelect;
    private JComboBox cbComparison;
    private JSlider slFeatureWeight;
    private JLabel sliderLabel;
    private JButton btnDelete;


    public ACFeatureSelect() {

        panelFeatureSelect.setSize(650, 200);
        panelFeatureSelect.repaint();

        slFeatureWeight.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent e) {
                sliderLabel.setText("" + slFeatureWeight.getValue());
            }
        });
        btnDelete.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JPanel parent = (JPanel) btnDelete.getParent().getParent();
                parent.remove(btnDelete.getParent());
                parent.repaint();
                parent.revalidate();
            }
        });
        cbFeature.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setComparisons(ACFeature.featureFactory(getFeature()).allowedCompareAlgorithms());
            }
        });
    }

    public static void main(String[] args) {
        JFrame frame = new JFrame("ACFeatureSelect");
        frame.setContentPane(new ACFeatureSelect().panelFeatureSelect);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.pack();
        frame.setVisible(true);
    }

    {
// GUI initializer generated by IntelliJ IDEA GUI Designer
// >>> IMPORTANT!! <<<
// DO NOT EDIT OR ADD ANY CODE HERE!
        $$$setupUI$$$();
    }

    /**
     * Method generated by IntelliJ IDEA GUI Designer
     * >>> IMPORTANT!! <<<
     * DO NOT edit this method OR call it in your code!
     *
     * @noinspection ALL
     */
    private void $$$setupUI$$$() {
        panelFeatureSelect = new JPanel();
        panelFeatureSelect.setLayout(new FormLayout("fill:max(d;180px):grow,left:4dlu:noGrow,fill:max(d;170px):grow,left:4dlu:noGrow,fill:200px:noGrow,left:4dlu:noGrow,fill:30px:noGrow,left:4dlu:noGrow,fill:45px:noGrow", "center:d:noGrow"));
        cbFeature = new JComboBox();
        CellConstraints cc = new CellConstraints();
        panelFeatureSelect.add(cbFeature, cc.xy(1, 1));
        cbComparison = new JComboBox();
        panelFeatureSelect.add(cbComparison, cc.xy(3, 1));
        slFeatureWeight = new JSlider();
        slFeatureWeight.setInverted(false);
        slFeatureWeight.setMajorTickSpacing(50);
        slFeatureWeight.setMaximum(100);
        slFeatureWeight.setMinimum(0);
        slFeatureWeight.setMinorTickSpacing(10);
        slFeatureWeight.setPaintLabels(false);
        slFeatureWeight.setPaintTicks(true);
        slFeatureWeight.setPaintTrack(true);
        slFeatureWeight.setSnapToTicks(false);
        slFeatureWeight.setValue(50);
        slFeatureWeight.setValueIsAdjusting(false);
        panelFeatureSelect.add(slFeatureWeight, cc.xy(5, 1, CellConstraints.FILL, CellConstraints.DEFAULT));
        sliderLabel = new JLabel();
        sliderLabel.setText("50");
        panelFeatureSelect.add(sliderLabel, cc.xy(7, 1));
        btnDelete = new JButton();
        btnDelete.setMaximumSize(new Dimension(30, 25));
        btnDelete.setMinimumSize(new Dimension(30, 25));
        btnDelete.setPreferredSize(new Dimension(30, 25));
        btnDelete.setText("x");
        btnDelete.setToolTipText("delete Feature");
        panelFeatureSelect.add(btnDelete, cc.xy(9, 1));
    }

    /**
     * @noinspection ALL
     */
    public JComponent $$$getRootComponent$$$() {
        return panelFeatureSelect;
    }
}
