package main;
/***

music meta library

2009-05-20	mac		created

 **/
 
import features.*;

import java.util.*;
import java.io.*;

public class ACLibrary
{
	private String metaFolder;
	public ArrayList<ACMeta> mfiles;
	
	public ACLibrary()
	{
		metaFolder = "";
		mfiles = new ArrayList<ACMeta>();
	}
	
	public ACLibrary(String loadFolder)
	{
		loadMeta(metaFolder);
	}
	
	public void status()
	{
		if (metaFolder.equals(""))
		{
			System.out.println("[library]\t no library loaded");
		}
		else
		{
		  System.out.println("[library]\t " + metaFolder);
			System.out.println("[library]\t " + mfiles.size() + " files loaded");
		}
	}
	
	public void print(String fname)
	{
	  for (int i = 0; i < mfiles.size(); i++)
	  {
	    ACMeta m = mfiles.get(i);
	    if ( m.sourceFile.substring(m.sourceFile.lastIndexOf("/")+1).equals(fname))
	    {
	      m.print();
	    }
	  }
	}

    public void analyseMetaCompute(String src, String mfolder, File f)
    {
        for (File sf : f.listFiles())
        {
            if (sf.isDirectory()) analyseMetaCompute(src,mfolder,sf);
            else
            {
                System.out.println("[reading]\t" + sf.getAbsolutePath());

                ACMeta nm = new ACMeta();
                nm.analyseFile(sf.getAbsolutePath(), src);
                String mname = nm.relPath.replace("/", "_");
                mname = mname.replace("\\", "_");
                nm.store(mfolder + "/" + mname  + ".meta");
            }

        }
    }
	
	public void analyseMeta(String src, String mfolder)
	{
	  //read metadata from all files in src directory, write to mfolder  
	  metaFolder = src;

	  analyseMetaCompute(src, mfolder, new File(src));
	}
	
	public String[] loadMeta(String src)
	{
		//load all meta files in folder src
		metaFolder = src;
		
		mfiles = new ArrayList<ACMeta>();
		
		File dir = new File(src);
	  
	  String[] files = dir.list();
      String[] relpaths = new String[files.length];
	  
	  for (int i = 0; i < files.length; i++)
	  {
	    try
	    {
  	    System.out.println("[loading]\t" + src + "/" + files[i]);
 

        ACMeta am = new ACMeta();

        BufferedReader in = new BufferedReader(new FileReader(src + "/" + files[i]));

        //header
        in.readLine();
        am.sourceFile = in.readLine();
        am.relPath = in.readLine();



        String sn;
        while ( (sn = in.readLine()) != null)
        {
            ACFeature f = ACFeature.featureFactory(sn);
            f.deserialise(in);
            am.features.add(f);
            
        }

            mfiles.add(am);
        relpaths[i] = am.relPath;

        in.close();
      }
      catch (Exception ex)
      {
      }
	  }
        return relpaths;
	}
}