package main;
/***

 music meta wrapper

 2009-05-20	mac		created

 **/

import java.util.*;

import jm.JMC;
import jm.music.data.Score;
import jm.music.data.Part;
import jm.music.data.Phrase;
import jm.music.data.Note;
import jm.music.tools.*;
import jm.util.*;

import java.util.*;
import java.io.*;

import features.*;


public class ACMeta implements java.io.Serializable {
    private static final long serialVersionUID = 1;

    public ArrayList<ACFeature> features;

    private Score score;
    public String sourceFile;
    public String relPath;

    public ACMeta() {
        features = new ArrayList<ACFeature>();
    }

    public void print() {
        for (int i = 0; i < features.size(); i++) {
            ACFeature acf = (ACFeature) features.get(i);

            acf.print();
        }
    }

    public ACFeature getFeatureByID(String featureID) {
        for (ACFeature f : features) {
            if (f.featureID.equals(featureID)) return f;
        }

        return null;
    }

    public void store(String target) {
        try {
            score = null;

            BufferedWriter out = new BufferedWriter(new FileWriter(target));
            out.write("AudioCompare Metadata, Version 1.1\n");
            out.write(sourceFile);
            out.write("\n");
            out.write(relPath);
            out.write("\n");
            for (ACFeature acf : features) {
                out.write(acf.serialise());
            }
            out.close();


        }
        catch (Exception ex) {
        }
    }

     public void analyseFile(String src) {
        //extract from source file
        sourceFile = src;
        relPath = src;
        score = new Score();
        Read.midi(score, src);
        analyseFile(score);

    }

    public void analyseFile(String src, String path) {
        //extract from source file
        sourceFile = src;
        relPath = src.substring(path.length()+1);
        score = new Score();
        Read.midi(score, src);
        analyseFile(score);

    }

    public void analyseFile(Score score) {
        for (String s : ACFeature.getFeatureIds()) {
            ACFeature f = ACFeature.featureFactory(s);
            f.extract(score);
            features.add(f);
        }
    }
}